# See https://aka.ms/customizecontainer to learn how to customize your debug container and how Visual Studio uses this Dockerfile to build your images for faster debugging.

# This stage is used when running from VS in fast mode (Default for Debug configuration)
FROM 10.99.253.167:8090/dotnet/runtime:9.0 AS base
WORKDIR /app


# This stage is used to build the service project
FROM 10.99.253.167:8090/dotnet/sdk:9.0 AS build
ARG BUILD_CONFIGURATION=Release
USER root
WORKDIR /src
COPY ["NuGet.config", "."]
COPY ["PARR.TemplateMatcherWorker/PARR.TemplateMatcherWorker.csproj", "PARR.TemplateMatcherWorker/"]
COPY ["PARR.TemplateMatcher/PARR.TemplateMatcher.csproj", "PARR.TemplateMatcher/"]
COPY ["PARR.Core/PARR.Core.csproj", "PARR.Core/"]
COPY ["PARR.Domain/PARR.Domain.csproj", "PARR.Domain/"]
COPY ["PARR.DAL/PARR.DAL.csproj", "PARR.DAL/"]
COPY ["PARR.Infrastructure/PARR.Infrastructure.csproj", "PARR.Infrastructure/"]
RUN dotnet restore "./PARR.TemplateMatcherWorker/PARR.TemplateMatcherWorker.csproj"
COPY . .
WORKDIR "/src/PARR.TemplateMatcherWorker"
RUN dotnet build "./PARR.TemplateMatcherWorker.csproj" -c $BUILD_CONFIGURATION -o /app/build

# This stage is used to publish the service project to be copied to the final stage
FROM build AS publish
ARG BUILD_CONFIGURATION=Release
ARG app_version=0.0.0-default
RUN dotnet publish "./PARR.TemplateMatcherWorker.csproj" -c $BUILD_CONFIGURATION -o /app/publish /p:UseAppHost=false /p:Version=$app_version

# This stage is used in production or when running from VS in regular mode (Default when not using the Debug configuration)
FROM base AS final
WORKDIR /app
COPY --from=publish /app/publish .
ENTRYPOINT ["dotnet", "PARR.TemplateMatcherWorker.dll"]